/*
	Copyright (C) 2007 Belhorma Bendebiche
	
	This file is part of FreeDL.

	FreeDL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	FreeDL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with FreeDL.  If not, see <http://www.gnu.org/licenses/>.
*/

#include <iostream>

#include "socket.h"

using namespace std;

int main(int argc, char **argv)
{
	auto_ptr<Socket> sock(new Socket());
	string request = "GET / HTTP/1.1\nHost: www.google.com\nConnection: close\n\n";
	
	try
	{
		sock->SetRemote("www.google.com", 80);
		//sock->Connect();
	}
	catch (DNSErrorException)
	{
		cout<<"DNS error!"<<endl;
	}
	catch (ConnectErrorException& ex)
	{
		cout<<"Connect error: "<<ex.reason()<<endl;
	}
	cout<<"Hello, world!"<<endl;
	
	return 0;
}
