/*
	Copyright (C) 2007 Belhorma Bendebiche
	
	This file is part of FreeDL.

	FreeDL is free software: you can redistribute it and/or modify
	it under the terms of the GNU General Public License as published by
	the Free Software Foundation, either version 3 of the License, or
	(at your option) any later version.

	FreeDL is distributed in the hope that it will be useful,
	but WITHOUT ANY WARRANTY; without even the implied warranty of
	MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
	GNU General Public License for more details.

	You should have received a copy of the GNU General Public License
	along with FreeDL.  If not, see <http://www.gnu.org/licenses/>.
*/

#ifndef _SOCKET_H_
#define _SOCKET_H_

#include <netdb.h>
#include <sys/types.h>
#include <netinet/in.h>
#include <sys/socket.h>
#include "errno.h"

#include <string>
#include <exception>

using namespace std;

class DNSErrorException {};
class ConnectErrorException
{
	string reason;
public:
	void reason()
	{
		return reason;
	}
	
	ConnectErrorException(string reason)
	{
		this->reason = reason;
	}
};
class WouldBlockException : public ConnectErrorException {};
class InProgressException : public ConnectErrorException {};

class Socket
{
	int sockfd;h
	struct hostent *he;
	struct sockaddr_in remoteAddress;
public:
	string host;
	
	void SetRemote(string hostName, short port);
	
	void Connect();
	void Disconnect();
	
	int Send(const void *data, int size);
	int Receive(void *data, int size);
	
	Socket();
	Socket(string hostName, short port);
	~Socket();
};

#endif
